#include <stdio.h>
#include <stdlib.h>

/* Linked list node */
struct rec {
	int a[4]; // 4 *4 = 16 bytes
	size_t i; // 8 bytes

	/* In C++ we could say just "rec *", but in C we need "struct" */
	struct rec *next; // 8 bytes
};

int *get_ap(struct rec *r, size_t idx)
{
	return &r->a[idx];
}

void set_val(struct rec *r, int val)
{
	while (r)
	{
		size_t i = r->i;
		r->a[i] = val;
		r = r->next;
	}
}

int main()
{
	struct rec *head = calloc(1, sizeof(struct rec));
	struct rec *second = calloc(1, sizeof(struct rec));
	head->i = 1;
	second->i = 2;
	head->next = second;
	second->next = NULL;

	int *iptr = get_ap(head, 0);
	*iptr = 4;

	set_val(head, 8);

	struct rec *ptr = head;
	while (ptr)
	{
		printf("Node at %p: %zu [%d %d %d %d] -> %p\n",
		       ptr, ptr->i,
		       ptr->a[0], ptr->a[1], ptr->a[2], ptr->a[3],
		       ptr->next);
		ptr = ptr->next;
	}

	free(head);
	free(second);
}
